diff --git a/src/main/java/net/minecraft/core/net/command/Commands.java b/src/main/java/net/minecraft/core/net/command/Commands.java
index ee57ac78d..1d80ffa80 100644
--- a/src/main/java/net/minecraft/core/net/command/Commands.java
+++ b/src/main/java/net/minecraft/core/net/command/Commands.java
@@ -1,36 +1,7 @@
 package net.minecraft.core.net.command;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.net.command.commands.BiomeCommand;
-import net.minecraft.core.net.command.commands.ChunkCommand;
-import net.minecraft.core.net.command.commands.ClearCommand;
-import net.minecraft.core.net.command.commands.ColorCommand;
-import net.minecraft.core.net.command.commands.DeopCommand;
-import net.minecraft.core.net.command.commands.DifficultyCommand;
-import net.minecraft.core.net.command.commands.EmotesCommand;
-import net.minecraft.core.net.command.commands.GamemodeCommand;
-import net.minecraft.core.net.command.commands.GameruleCommand;
-import net.minecraft.core.net.command.commands.GenerateCommand;
-import net.minecraft.core.net.command.commands.GiveCommand;
-import net.minecraft.core.net.command.commands.HelpCommand;
-import net.minecraft.core.net.command.commands.KillCommand;
-import net.minecraft.core.net.command.commands.ListCommand;
-import net.minecraft.core.net.command.commands.NicknameCommand;
-import net.minecraft.core.net.command.commands.OpCommand;
-import net.minecraft.core.net.command.commands.PlaySoundCommand;
-import net.minecraft.core.net.command.commands.ScoreCommand;
-import net.minecraft.core.net.command.commands.SeedCommand;
-import net.minecraft.core.net.command.commands.SetBlockCommand;
-import net.minecraft.core.net.command.commands.SetSpawnCommand;
-import net.minecraft.core.net.command.commands.SpawnCommand;
-import net.minecraft.core.net.command.commands.SpawnParticleCommand;
-import net.minecraft.core.net.command.commands.StopCommand;
-import net.minecraft.core.net.command.commands.SummonCommand;
-import net.minecraft.core.net.command.commands.TeleportCommand;
-import net.minecraft.core.net.command.commands.TimeCommand;
-import net.minecraft.core.net.command.commands.WeatherCommand;
-import net.minecraft.core.net.command.commands.WhisperCommand;
-import net.minecraft.core.net.command.commands.WhoisCommand;
+import net.minecraft.core.net.command.commands.*;
 import net.minecraft.server.MinecraftServer;
 
 import java.util.ArrayList;
@@ -63,6 +34,7 @@ public final class Commands {
 		commands.add(new BiomeCommand());
 		commands.add(new SpawnParticleCommand());
 		commands.add(new PlaySoundCommand());
+		commands.add(new HarmCommand());
 	}
 	
 	public static void initServerCommands(MinecraftServer server) {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java b/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java
new file mode 100644
index 000000000..a2a21d812
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/HarmCommand.java
@@ -0,0 +1,68 @@
+package net.minecraft.core.net.command.commands;
+
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.net.command.Command;
+import net.minecraft.core.net.command.CommandError;
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.util.helper.DamageType;
+
+public class HarmCommand extends Command
+{
+    public HarmCommand() {
+        super("harm");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args)
+    {
+        if (args.length == 0)
+        {
+            EntityPlayer player = sender.getPlayer();
+            player.hurt(player, 1, DamageType.GENERIC);
+
+            sender.sendMessage("Harmed player " + player.getDisplayName() + "for 1");
+            return true;
+        }
+        else if (args.length == 1)
+        {
+            EntityPlayer player = handler.getPlayer(args[0]);
+            if (player == null) return false;
+
+            player.hurt(player, 1, DamageType.GENERIC);
+            sender.sendMessage("Harmed player " + player.getDisplayName() + "for 1");
+            return true;
+        }
+        else if (args.length == 2)
+        {
+            EntityPlayer player = handler.getPlayer(args[0]);
+            int damageAmount = parseInt(args[1]);
+            if (player == null) return false;
+
+            player.hurt(player, damageAmount, DamageType.GENERIC);
+            sender.sendMessage("Harmed player " + player.getDisplayName() + "for " + damageAmount);
+            return true;
+        }
+
+        return false;
+    }
+
+    public int parseInt(String str) {
+        try {
+            return Integer.parseInt(str);
+        }catch (Exception e) {
+            throw new CommandError("Not an integer: \""+str+"\"");
+        }
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/harm");
+        sender.sendMessage("/harm <username> <amount>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java b/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
index 5dc4f4227..843f079b3 100644
--- a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
+++ b/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
@@ -55,7 +55,7 @@ public class ScreenShot
 
             }
 
-            BufferedImage bufferedimage = new BufferedImage(width, height, 1);
+            BufferedImage bufferedimage = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
             bufferedimage.setRGB(0, 0, width, height, imageData, 0, width);
             ImageIO.write(bufferedimage, "png", file2);
             try {
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index caebad2d4..39c84d7c1 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -14,7 +14,9 @@ import java.util.TreeSet;
 
 import com.mojang.nbt.CompoundTag;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
 import net.minecraft.core.Global;
 import net.minecraft.core.HitResult;
 import net.minecraft.core.NextTickListEntry;
@@ -61,6 +63,8 @@ import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeDebug;
+import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
 
@@ -270,6 +274,22 @@ public class World implements WorldSource {
 
         biomeProvider = this.worldType.createBiomeProvider(this);
     }
+    // Used for the model viewer
+    public World(){
+        this.dimension = Dimension.overworld;
+        this.saveHandler = null;
+        levelData = new LevelData(0, "modelviewer");
+        this.worldType = WorldTypes.DEBUG;
+        chunkProvider = new ChunkProviderViewer(this);
+        seasonManager = SeasonManager.fromConfig(this, this.worldType.getDefaultSeasonConfig());
+        updateSkyBrightness();
+
+        this.weatherManager = new WeatherManager(this);
+
+        auroraProvider = new AuroraProvider(this, 0);
+
+        biomeProvider = this.worldType.createBiomeProvider(this);
+    }
 
     public <T> T getGameRule(GameRule<T> gameRule)
     {
@@ -1061,15 +1081,21 @@ public class World implements WorldSource {
         }
     }
 
+	@Override
+	public float getBrightness(int x, int y, int z, int blockLightValue) {
+		int i1 = getBlockLightValue(x, y, z);
+		if(i1 < blockLightValue) {
+			i1 = blockLightValue;
+		}
+		return worldType.getBrightnessRamp()[i1];
+	}
+    
     @Override
-    public float getBrightness(int x, int y, int z, int blockLightValue)
-    {
-        int i1 = getBlockLightValue(x, y, z);
-        if(i1 < blockLightValue)
-        {
-            i1 = blockLightValue;
-        }
-        return worldType.getBrightnessRamp()[i1];
+    public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
+		int skyLight = getSavedLightValue(LightLayer.Sky, x, y, z);
+		int blockLight = Math.max(getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
+		
+		return LightmapHelper.getLightmapCoord(skyLight, blockLight);
     }
 
     @Override
@@ -1112,7 +1138,7 @@ public class World implements WorldSource {
         int id = getBlockId(blockStartX, blockStartY, blockStartZ);
         int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
         Block block = Block.blocksList[id];
-        if((!flag1 || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && block.canCollideCheck(meta, shouldCollideWithFluids))
+        if((!flag1 || block == null || block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) != null) && id > 0 && (block.canCollideCheck(meta, shouldCollideWithFluids)))
         {
             HitResult movingobjectposition = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end);
             if(movingobjectposition != null)
@@ -1518,6 +1544,28 @@ public class World implements WorldSource {
 
         return collidingBoundingBoxes;
     }
+	
+	public float getAmbientBrightness(float partialTicks) {
+		float angle = getCelestialAngle(partialTicks);
+		float bright = 1.0F - (MathHelper.cos(angle * 3.141593F * 2.0F) * 2.0F + 0.2F);
+		bright = 1.0f - MathHelper.clamp(bright, 0.0f, 1.0f);
+		
+		Weather weather = weatherManager.getCurrentWeather();
+		if(weather != null) {
+			// TODO Unhardcode somehow
+			if(weather == Weather.overworldRain) {
+				float power = weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower();
+				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));	
+			}
+			if(weather == Weather.overworldStorm) {
+				float power = weatherManager.getWeatherIntensity() * weatherManager.getWeatherPower();
+				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));
+				bright = (float) (bright * (1.0 - (power * 5.0f) / 16.0));
+			}
+		}
+		
+		return bright * 0.8f + 0.2f;
+	}
 
     public Vec3d getSkyColor(ICamera camera, float partialTick)
     {
diff --git a/src/main/java/net/minecraft/core/world/WorldSource.java b/src/main/java/net/minecraft/core/world/WorldSource.java
index de1b74b9b..10699959d 100644
--- a/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -4,8 +4,6 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.provider.BiomeProvider;
-import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.SeasonManager;
 
 public interface WorldSource
@@ -18,6 +16,8 @@ public interface WorldSource
     TileEntity getBlockTileEntity(int x, int y, int z);
 
     float getBrightness(int x, int y, int z, int blockLightValue);
+    
+    int getLightmapCoord(int x, int y, int z, int blockLightValue);
 
     float getLightBrightness(int x, int y, int z);
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 805af9a82..712560b4a 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -1,16 +1,17 @@
 package net.minecraft.core.world.chunk;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.world.World;
+
 // Referenced classes of package net.minecraft.src:
 //            IBlockAccess, World, Chunk, WorldProvider, 
 //            Block, Material, TileEntity, WorldChunkManager
 
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.season.SeasonManager;
 
 public class ChunkCache
@@ -99,16 +100,22 @@ public class ChunkCache
         }
     }
 
-    @Override
-	public float getBrightness(int x, int y, int z, int blockLightValue)
-    {
-        int i1 = getLightValue(x, y, z);
-        if(i1 < blockLightValue)
-        {
-            i1 = blockLightValue;
-        }
-        return worldObj.worldType.getBrightnessRamp()[i1];
-    }
+	@Override
+	public float getBrightness(int x, int y, int z, int blockLightValue) {
+		int i1 = getLightValue(x, y, z);
+		if(i1 < blockLightValue) {
+			i1 = blockLightValue;
+		}
+		return worldObj.worldType.getBrightnessRamp()[i1];
+	}
+
+	@Override
+	public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
+		int skyLight = worldObj.getSavedLightValue(LightLayer.Sky, x, y, z);
+		int blockLight = Math.max(worldObj.getSavedLightValue(LightLayer.Block, x, y, z), blockLightValue);
+		
+		return skyLight << 20 | blockLight << 4;
+	}
 
     @Override
 	public float getLightBrightness(int x, int y, int z)
diff --git a/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
new file mode 100644
index 000000000..ec705341c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.world.chunk;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.world.World;
+
+public class DisplayChunk extends EmptyChunk{
+    public static int displayBlockId = 0;
+    public static int displayBlockMeta = 0;
+    public static int displayBlockPosX = 0;
+    public static int displayBlockPosY = 0;
+    public static int displayBlockPosZ = 0;
+    public static TileEntity displayTileEntity = null;
+    public DisplayChunk(World world, int x, int z) {
+        super(world, x, z);
+    }
+    @Override
+    public int getBlockID(int x, int y, int z)
+    {
+        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+            return displayBlockId;
+        }
+        return 0;
+    }
+    @Override
+    public int getBlockMetadata(int x, int y, int z)
+    {
+        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+            return displayBlockMeta;
+        }
+        return 0;
+    }
+    @Override
+    public int getBrightness(LightLayer layer, int x, int y, int z)
+    {
+        return 15;
+    }
+    @Override
+    public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
+    {
+        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+            displayTileEntity = tileEntity;
+            displayTileEntity.worldObj = world;
+            displayTileEntity.x = x;
+            displayTileEntity.y = y;
+            displayTileEntity.z = z;
+        }
+    }
+
+    @Override
+    public void removeTileEntity(int x, int y, int z)
+    {
+        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+            displayTileEntity = null;
+        }
+    }
+    @Override
+    public TileEntity getTileEntity(int x, int y, int z)
+    {
+        if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
+            return displayTileEntity;
+        }
+        return null;
+    }
+    public static void setDisplayTileEntity(World world, TileEntity entity){
+        displayTileEntity = entity;
+        if (displayTileEntity != null){
+            displayTileEntity.worldObj = world;
+            displayTileEntity.x = DisplayChunk.displayBlockPosX;
+            displayTileEntity.y = DisplayChunk.displayBlockPosY;
+            displayTileEntity.z = DisplayChunk.displayBlockPosZ;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 806b1a267..5bfae16bc 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -294,12 +294,12 @@ public class ChunkDecoratorOverworld
             byteOrchid = 1;
         }
         for (int l14 = 0; l14 < byteOrchid; l14++) {
-            int blockId = Block.flowerPink.id;
+            int[] flowerIds= { Block.flowerYellow.id, Block.flowerPink.id, Block.flowerRed.id };
 
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
             int j24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureTallGrass(blockId)).generate(world, rand, l19, k22, j24);
+            (new WorldFeatureMeadow(flowerIds)).generate(world, rand, l19, k22, j24);
         }
 
         byte byteMeadow = 0;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
new file mode 100644
index 000000000..7117c3419
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -0,0 +1,45 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.world.World;
+import org.lwjgl.Sys;
+
+import java.util.List;
+import java.util.Random;
+
+public class WorldFeatureMeadow extends WorldFeature
+{
+
+    public WorldFeatureMeadow(int[] blockIds)
+    {
+        this.blockIds = blockIds;
+    }
+
+    @Override
+    public boolean generate(World world, Random random, int x, int y, int z)
+    {
+        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int i1 = 0; i1 < 128; i1++)
+        {
+            int j1 = (x + random.nextInt(8)) - random.nextInt(8);
+            int k1 = (y + random.nextInt(4)) - random.nextInt(4);
+            int l1 = (z + random.nextInt(8)) - random.nextInt(8);
+
+            int meta = 0;
+
+            int index = random.nextInt(blockIds.length);
+            int flowerId = blockIds[index];
+
+
+            if(world.isAirBlock(j1, k1, l1) && Block.blocksList[flowerId].canBlockStay(world, j1, k1, l1))
+            {
+                world.setBlockAndMetadata(j1, k1, l1, flowerId, meta);
+            }
+        }
+
+        return true;
+    }
+
+    private final int[] blockIds;
+}
diff --git a/src/main/java/net/minecraft/core/world/type/WorldType.java b/src/main/java/net/minecraft/core/world/type/WorldType.java
index 54c62c39f..f7c43bfea 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -1,13 +1,11 @@
 package net.minecraft.core.world.type;
 
-import net.minecraft.core.Global;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.wind.WindManager;
 
